﻿using Chapter1.Sample2;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter1
{
    namespace Snippet1
    {
        public class MyData
        {
            public Int32 Value { get; internal set; }

            internal MyData CreateCopy()
            {
                throw new NotImplementedException();
            }
        }
        public class Sample
        {
            private MyData myData;
            public MyData Foo() => myData;

            public MyData Foo2() => myData.CreateCopy();

            private int TotalSum;

            public void Tests()
            {
                // call it:
                MyData v = Foo();
                TotalSum += v.Value;
            }
        }
    }

    namespace Sample2
    {
        public interface IMyInterface
        {
            void DoWork();
        }
        public class MyType : IMyInterface
        {
            public void DoWork()
            {
                throw new NotImplementedException();
            }
        }

        public class Sample
        {
            private MyType myType;
            public IMyInterface Foo3() => myType as IMyInterface;

            public void Example()
            {
                // call it:
                IMyInterface iMe = Foo3();
                iMe.DoWork();
            }

        }
    }

    namespace Sample4
    {
        public class C
        {
            private MyType a = new MyType();
            private MyType b = new MyType();

            // Remaining implementation removed.
        }

        public static class Example
        {
            public static void M()
            {
                C cThing = new C();
                MyType[] arrayOfTypes = new MyType[100];
            }
        }

        public class BankAccount
        {
            internal Decimal Balance;
        }
        public struct Employee
        {
            // Properties elided
            public string Position
            {
                get;
                set;
            }

            public decimal CurrentPayAmount
            {
                get;
                set;
            }

            public void Pay(BankAccount b) 
                => b.Balance += CurrentPayAmount;
        }

    }

    namespace Sample5
    {
        public class Employee
        {
            // Properties elided
            public string Position
            {
                get;
                set;
            }

            public decimal CurrentPayAmount
            {
                get;
                set;
            }

            public virtual void Pay(BankAccount b)
            {
                b.Balance += CurrentPayAmount;
            }
        }
        public class BankAccount
        {
            internal Decimal Balance;
        }

        public static class Test
        {
            public static List<Employee> Employees = new List<Employee>();
            public static void Tests()
            {
                Employee e1 = Employees.Find(e => e.Position == "CEO");
                BankAccount CEOBankAccount = new BankAccount();
                decimal Bonus = 10000;
                e1.CurrentPayAmount += Bonus; // Add one time bonus.
                e1.Pay(CEOBankAccount);

            }
        }
    }
    class Item04
    {
        public static void Tests()
        {

        }
    }
}
