﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    class Item11
    {
        public static double ComputeArea(Ellipse e) =>
            e.R1 * e.R2 * Math.PI;

        public static void Flatten(Ellipse e)
        {
            e.R1 /= 2;
            e.R2 *= 2;
        }

        public static void Tests()
        {
            // call it:
            Circle c1 = new Circle(new Point(3.0, 0), 5.0);
            ComputeArea(c1);


            // call it using a circle:
            Circle c = new Circle(new Point(3.0, 0), 5.0);
            Flatten(c);

            Flatten((Ellipse)c);
            Flatten(new Ellipse(c));
        }

        private static void FinalSample()
        {
            Circle c = new Circle(new Point(3.0, 0), 5.0);
            Flatten(c);
            // Work with the circle.
            // ...

            // Convert to an ellipse.
            Ellipse e = new Ellipse(c);
            Flatten(e);

        }

    }


    public class Point
    {
        public Point()
        {

        }

        public Point(double v1, int v2)
        {
            X= v1;
            Y = v2;
        }

        public double X { get; set; }
        public double Y { get; set; }
    }
    public abstract class Shape
    {
        public abstract void Draw();
    }

    public class Ellipse : Shape
    {
        private Circle c;
        private Point center1;
        private Point center2;
        private double radius1;
        private double radius2;

        public Ellipse(Circle c)
        {
            this.c = c;
        }

        public Ellipse(Point center1, Point center2, double radius1, double radius2)
        {
            this.center1 = center1;
            this.center2 = center2;
            this.radius1 = radius1;
            this.radius2 = radius2;
        }

        public int R1 { get; internal set; }
        public int R2 { get; internal set; }

        public override void Draw()
        {
            throw new NotImplementedException();
        }
    }

    public class Circle : Shape
    {
        private Point center;
        private double radius;

        public Circle() :
            this(new Point(), 0)
        {
        }

        public Circle(Point c, double r)
        {
            center = c;
            radius = r;
        }

        public override void Draw()
        {
            //...
        }

        static public implicit operator Ellipse(Circle c)
        {
            return new Ellipse(c.center, c.center,
              c.radius, c.radius);
        }
    }

}
