﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter3_Task
{
    class Item25
    {
        public static void Tests()
        {
            Task t = SomeMethodAsync();
            Console.WriteLine("In Main, after calling SomeMethodAsync");
            t.Wait();
            Console.WriteLine("In Main, after calling Wait()");
        }

        // This is the async method. It's allowed to contain await
        // expressions, and must return void, Task or Task<T>.
        static async Task SomeMethodAsync()
        {
            Console.WriteLine("Entering SomeMethodAsync");
            Task<int> awaitable = SomeMethodReturningTask();

            Console.WriteLine("In SomeMethodAsync, before the await");

            // An awaitable has to follow a prescribed pattern. It doesn't
            // always have to be Task or Task<T>, but usually it will be.
            var result = await awaitable;

            Console.WriteLine("In SomeMethodAsync, after the await");
        }

        // This is the method which produces the awaitable. It doesn't
        // have to be an async method, although it certainly could be.
        static async Task<int> SomeMethodReturningTask()
        {
            await Task.Factory.StartNew(() =>
            {
                Console.WriteLine("In the task. Delaying...");
                Task.Delay(2000);
                Console.WriteLine("Task finished now");
            });
            return 42;
        }

    }
}
