﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter3
{
    public class Item25
    {

        public static void Tests()
        {

        }

        private static void SnippetOne()
        {
            var data = Enumerable.Range(1, 100);

            var nums = data.Where(m => m < 150).
                Select(n => Factorial(n));

            var numsParallel = data.AsParallel().
                Where(m => m < 150).Select(n => Factorial(n));

        }

        private static void SnippetTWo()
        {
            var data = Enumerable.Range(1, 100);

            var nums = from n in data
                       where n < 150
                       select Factorial(n);

            var stopAndGoArray = (from n in data.AsParallel()
                                  where n < 150
                                  select Factorial(n)).ToArray();

            var stopAndGoList = (from n in data.AsParallel()
                                 where n < 150
                                 select Factorial(n)).ToList();

        }

        private static void SnippetThree()
        {
            var data = Enumerable.Range(1, 100);

            var numsParallel = from n in data.AsParallel()
                               where n < 150
                               select Factorial(n);
            foreach (var item in numsParallel)
                Console.WriteLine(item);

            var nums2 = from n in data.AsParallel()
                        where n < 150
                        select Factorial(n);
            nums2.ForAll(item => Console.WriteLine(item));
        }

        private static void SnippetFour()
        {
            var answers = from n in Enumerable.Range(0, 300)
                          where n.SomeTest()
                          select n.SomeProjection();

            var iter = answers.GetEnumerator();

            Console.WriteLine("About to start iterating");
            while (iter.MoveNext())
            {
                Console.WriteLine("called MoveNext");
                Console.WriteLine(iter.Current);
            }

        }

        private static void Snippetfive()
        {
            var answers = from n in ParallelEnumerable.Range(0, 300)
                          where n.SomeTest()
                          select n.SomeProjection();

        }

        private static void SnippetSix()
        {
            var answers = (from n in ParallelEnumerable.Range(0, 300)
                           where n.SomeTest()
                           select n.SomeProjection()).
                          Skip(20).Take(20);

        }

        private static void SnippetSeven()
        {
            var answers = (from n in ParallelEnumerable.Range(0, 300)
                           where n.SomeTest()
                           orderby n.ToString().Length
                           select n.SomeProjection()).
                          Skip(20).Take(20);

        }

        private static int Factorial(int n)
        {
            int facimpl(int number)
            {
                return number < 2 ? number : number * facimpl(number - 1);
            }
            return facimpl(n);
        }
    }

    public static class LocalExtensions
    {

        public static bool SomeTest(this int inputValue)
        {
            Console.WriteLine($"testing element: {inputValue}");
            return inputValue % 10 == 0;
        }

        public static string SomeProjection(this int input)
        {
            Console.WriteLine($"projecting an element: {input}");
            return $"Delivered {input} at {DateTime.Now:T}";
        }
    }
}
