﻿using System;
using static System.Console;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter4
{
    public class MyType
    {
        public String StringMember { get; set; }

        public static implicit operator String(MyType aString)
            => aString.StringMember;

        public static implicit operator MyType(String aString)
            => new MyType { StringMember = aString };
    }

    public static class Item41
    {
        public static void SnippetOne()
        {
            var answer1 = GetSomeStrings().Cast<MyType>();
            try
            {
                foreach (var v in answer1)
                    WriteLine(v);
            }
            catch (InvalidCastException)
            {
                WriteLine("Cast Failed!");
            }
        }

        public static void SnippetTwo()
        {
            var answer2 = from MyType v in GetSomeStrings()
                          select v;
            try
            {
                foreach (var v in answer2)
                    WriteLine(v);
            }
            catch (InvalidCastException)
            {
                WriteLine("Cast failed again");
            }
        }

        public static void SnippetThree()
        {
            var answer3 = from v in GetSomeStrings()
                          select (MyType)v;
            foreach (var v in answer3)
                WriteLine(v);
        }

        public static void SnippetFour_Five()
        {
            var answer4 = GetSomeStrings().
                Select(n => new MyType { StringMember = n });
            var answer5 = from v in GetSomeStrings()
                          select new MyType { StringMember = v };

            var convertedSequence = GetSomeStrings().Convert<MyType>();
        }

        public static IEnumerable<TResult> Convert<TResult>(
            this System.Collections.IEnumerable sequence)
        {
            foreach (object item in sequence)
            {
                dynamic coercion = (dynamic)item;
                yield return (TResult)coercion;
            }
        }


        private static IEnumerable<string> GetSomeStrings()
        {
            yield return "one";
            yield return "two";
            yield return "three";
            yield return "four";
            yield return "five";
            yield return "six";
            yield return "seven";
            yield return "eight";
            yield return "nine";
            yield return "ten";

        }
    }
}
